#include "othello.h"

int Put(char *board, int place, int color, int flag)
/* ֤:placeˤˤҤä֤Ŀ (placeΤϴޤޤʤ) */
/* place:0..63 */
/* color place֤ (MY_COLOR,OP_COLOR 侩) */
/* flag  CHANGE:̤򹹿 NOT_CHANGE:̤򹹿ʤ */
/*       R_CHANGE:Ҥä֤Τդˤ(ɽ) */
{
  int n_x, n_y, i, f, j;
  int p_x, p_y;
  int now_p;
  int get_tmp, get_num;

  get_num = get_tmp = 0;

  if(board[place] != SPACE)
    return 0;

  if((flag == CHANGE) || (flag == R_CHANGE))
    board[place] = color;

  p_x = place % 8;
  p_y = place / 8;

  for(i = 0; i < 8; i++){
    n_x = p_x + direction_x[i];
    n_y = p_y + direction_y[i];
    f = 0;
    get_tmp = 0;
    while((n_x >= 0) && (n_x <= 7) && (n_y >= 0) && (n_y <= 7) &&
	  (board[n_y * 8 + n_x] != SPACE)){
      if(board[n_y * 8 + n_x] == color)
	if(f == 1){
	  get_num += get_tmp;
	  f = 2;
	}else
	  break;
      else{
	f = 1;
	get_tmp++;
	n_x += direction_x[i];
	n_y += direction_y[i];
      }
      
      if(f == 2){
	if((flag == CHANGE) || (flag == R_CHANGE)){ /* Ҥä֤ʤ */
	  f = 0;
	  now_p = n_y * 8 + n_x;
	  for(j = now_p - direction[i]; j != place; j -= direction[i])
	    if(flag == CHANGE)
	      board[j] = color;
	    else
	      board[j] = -color;
	  break;
	}
      }
    }
  }
  return get_num;
}

void CountDisks(char *board, int *my_c, int *op_c)
/* my_c:ʬζο op_c:ζο */
{
  int i;

  *my_c = *op_c = 0;
  for(i = 0; i < 64; i++)
    if(board[i] == MY_COLOR)
      (*my_c)++;
    else if(board[i] == OP_COLOR)
      (*op_c)++;

  return;
}

void Reverse(char *board)
/* MY_COLOR  OP_COLOR 촹() */
{
  int i;

  for(i = 0; i < 64; i++)
    if(board[i] == MY_COLOR)
      board[i] = OP_COLOR;
    else if(board[i] == OP_COLOR)
      board[i] = MY_COLOR;
}

void CopyBoard(char *src_b, char *dst_b, int reversep)
/* ̤Υԡ */
/* src_b:ԡ dst_b:ԡ */
/* reversep NORM:Τޤޥԡ REVERSE:MY_COLOROP_COLOR촹ƥԡ */
{
  int i;

  for(i = 0; i < 64; i++)
    if(reversep)
      if(src_b[i] == MY_COLOR)
	dst_b[i] = OP_COLOR;
      else if(src_b[i] == OP_COLOR)
	dst_b[i] = MY_COLOR;
      else
	dst_b[i] = src_b[i];
    else
      dst_b[i] = src_b[i];
}
